/* 
Sotres Catao Mario

Proyecto final. Caja fuerte que al estar abierta el usuario mete una clave x de cuatro digitos, la guarda y activa el motor para 
cerrar la tapa finalizando con un mensaje de "Cerrado".
Posteriormente el sistema espera hasta que el usuario ingresa otra contrasea para intentar abrir la caja y la compara con la
contrasea original con la que fue cerrada la caja. Si la contrasea es correcta activa el motor para mover la chapa y muestra
el mensaje de "Abierto", si la contrasea es incorrecta despliega el mensaje de "Error". Se repite el proceso sin necesidad de
presionar botn de reset.

Nota:El archivo 18F2550BOLT.h se modific para que los puertos A y C sean salidas.
*/

#include <p18cxxx.h>
#include <delays.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "18F2550BOLT.h"


extern void _startup( void ); // See c018i.c in your C18 compiler dir 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 

#pragma code
int i, abierto;
char array[7],error[10]={"Error"}, abre[10]={"Abierto"}, cerrado[10]={"Cerrado"};
void main()
{
	init_bolt();
	InitLCD();
	abierto=1;
	while(1){	
		while(abierto==1){								//El usuario ingresa la contrasea que desea para cerrar la caja.
			ClearScreen();
			PutLCD('>');
			SetBot();
			for(i=0; i<7; i++){							//Guardamos la contrasea en "array"
				array[i]=bot[i];
				abierto=0;
			}
			init_bolt();								//Se vuelve a llamar a init_bolt() porque SetBot pone de nuevo los puertos
														//A y C como entradas.

			for(i=0; i<120; i++){						//Activamos el motor para cerrar la chapa
				SW1=1; SW2=1; SW3=0; SW4=0; 
				delay_ms(2);
				SW1=0; SW2=1; SW3=1; SW4=0;
				delay_ms(2);
				SW1=0; SW2=0; SW3=1; SW4=1;
				delay_ms(2);
				SW1=1; SW2=0; SW3=0; SW4=1;
				delay_ms(2);
			}
			ClearScreen();								//Una vez cerrada la caja desplegamos "Cerrado".
			PrintString(cerrado);
			delay_ms(1500);
			ClearScreen();
		}
		while(abierto==0){								//El sistema espera hasta que el usuario ingresa la contrasea
			PutLCD('>');								//y la compara con la contrasea original que ingres anteriormente.
			SetBot();
			if(strcmp(bot,array)==0){					//Si la contrasea es correcta activa el motor.
				init_bolt();
				for(i=0; i<120; i++){					//Activamos el motor para abrir la chapa
					SW1=0; SW2=0; SW3=1; SW4=1;
					delay_ms(2);
					SW1=0; SW2=1; SW3=1; SW4=0;
					delay_ms(2);
					SW1=1; SW2=1; SW3=0; SW4=0;
					delay_ms(2);
					SW1=1; SW2=0; SW3=0; SW4=1;
					delay_ms(2);
				}						
				ClearScreen();							//Una vez abierta la caja mostramos el mensaje "Abierto".
				PrintString(abre);
				delay_ms(1500);
				abierto=1;
				ClearScreen();
			}
			else{										//Si la contrasea no es correcta mostramos el mensaje de "Error"
				ClearScreen();							//y esperamos a que vuelva a ingresar otra contrasea para comparar
				PrintString(error);						//de nuevo.
				delay_ms(1500);
				ClearScreen();
			}	
		}		
	}
}	

